# -*- coding: utf-8 -*-
import gtk
import pygtk
import os
import urllib

###aggiunge link dell'utente

class Add() :

    def __init__(self):
        builder = gtk.Builder()
        builder.add_from_file("add-ui.xml") 
        builder.connect_signals(self)
        self.window_add = builder.get_object("window_add")
        self.link_entry = builder.get_object("link_entry")
        self.nome_entry = builder.get_object("nome_entry")
        self.annulla_button = builder.get_object("annulla_button")
        self.aggiungi_button = builder.get_object("aggiungi_button")
        self.combobox1 = builder.get_object("combobox1")

        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer'
        
        ####riempie combobox1
        self.liststore = gtk.ListStore(str)
        self.cell = gtk.CellRendererText()
        self.combobox1.pack_start(self.cell)
        self.combobox1.set_attributes(self.cell, text=0)
        
        self.liststore.append(["TV"])
        self.liststore.append(["RADIO"])
        self.combobox1.set_model(self.liststore)
        self.combobox1.set_active(0)
        ######

        self.window_add.show()

    def aggiungi(self,nome_entry):
        print self.nome_entry.get_text()
        print self.link_entry.get_text()
        if self.combobox1.get_active()==0:
            type = "tv"
        else:
            type = "radio"
        file=open(os.path.expanduser(self.config_dir + '/personal_'+type+'.list'), 'a')
        file.write(self.nome_entry.get_text()+" #"+self.link_entry.get_text()+"\n")
        file.close()
        self.window_add.hide()
        gtk.main_quit()

    def annulla(self,window_add):
        self.window_add.hide()
        gtk.main_quit()
 
    def main(self):
        gtk.main()


class AddDatabase() :
    
    def __init__(self, lista):
        builder = gtk.Builder()
        builder.add_from_file("addDatabase-ui.xml") 
        builder.connect_signals(self)
        self.window_Data = builder.get_object("window_Data")
        self.treeview1 = builder.get_object("treeview1")
        self.combobox1 = builder.get_object("combobox1")
        self.entry_link = builder.get_object("entry_link")
        self.button_add = builder.get_object("button_add")
        self.button_cancel = builder.get_object("button_cancel")
        
        self.lista=lista
        
        ###treeview Database
        self.model = gtk.ListStore(str,str,str)
        self.treeview1.set_model(self.model)

        self.treecol1 = gtk.TreeViewColumn("Lista DATABASE")
        self.cellrenderer1 = gtk.CellRendererText()
        self.treecol1.pack_start(self.cellrenderer1, False)
        self.treecol1.set_attributes(self.cellrenderer1, text = 0)
        self.treeview1.append_column(self.treecol1)
        
        self.treecol2 = gtk.TreeViewColumn("Tipo")
        self.cellrenderer2 = gtk.CellRendererText()
        self.treecol2.pack_start(self.cellrenderer2, False)
        self.treecol2.set_attributes(self.cellrenderer2, text = 1)
        self.treeview1.append_column(self.treecol2)
		###
		
        ###liststore del combobox
        self.liststore = gtk.ListStore(str)
        self.cell = gtk.CellRendererText()
        self.combobox1.pack_start(self.cell)
        self.combobox1.set_attributes(self.cell, text=0)
        
        self.liststore.append(["TUTTO"])
        self.liststore.append(["SOLO TV"])
        self.liststore.append(["SOLO RADIO"])
        self.combobox1.set_model(self.liststore)
        self.combobox1.set_active(0)
        #######
        

        
        
        self.NOME_CANALE = ""
        self.TIPO_CANALE = ""

        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer'

        self.window_Data.show()

    def main(self):

        gtk.main()
        
    def cambia_ordine(self,data=None):

        if self.combobox1.get_active()==0:
			
            ###riempie lista DATABASE
            self.model.clear()

            self.sort_DATABASE = self.lista.keys()
            self.sort_DATABASE.sort()
            for i in self.sort_DATABASE :
                tmp = i.split('#')
                self.model.append ([tmp[0],tmp[1].upper(),self.lista[i]])
	    	###
	    	
        if self.combobox1.get_active()==1:
			
	    	###riempie lista DATABASE solo tv
            self.model.clear()

            self.sort_DATABASE = self.lista.keys()
            self.sort_DATABASE.sort()
            for i in self.sort_DATABASE :
                tmp = i.split('#')
                if tmp[1]=="tv":
					self.model.append ([tmp[0],tmp[1].upper(),self.lista[i]])
	    	###
	    	
        if self.combobox1.get_active()==2:
			
	    	###riempie lista DATABASE solo radio
            self.model.clear()

            self.sort_DATABASE = self.lista.keys()
            self.sort_DATABASE.sort()
            for i in self.sort_DATABASE :
                tmp = i.split('#')
                if tmp[1]=="radio":
					self.model.append ([tmp[0],tmp[1].upper(),self.lista[i]])
	    	###

    def link_canale(self, treeview1):
            self.treeselection = self.treeview1.get_selection()
            (model,iter) = self.treeselection.get_selected()
            url = self.model.get_value(iter, 2)
            self.NOME_CANALE = self.model.get_value(iter, 0)
            self.TIPO_CANALE = self.model.get_value(iter, 1)
            self.entry_link.set_text(url)
    

    def aggiungi(self,entry_link,data=None,data2=None):
        if self.TIPO_CANALE == 'TV':
            file=open(self.config_dir + '/personal_tv.list', 'a')
            file.write(self.NOME_CANALE+" #"+self.entry_link.get_text()+"\n")
            file.close
            self.window_Data.hide()
            gtk.main_quit()
            print "asd"
        if self.TIPO_CANALE == 'RADIO':
            file=open(self.config_dir + '/personal_radio.list', 'a')
            file.write(self.NOME_CANALE+" #"+self.entry_link.get_text()+"\n")
            file.close()
            self.window_Data.hide()
            gtk.main_quit()
            print "asd"

    def annulla(self,window_Data):
        self.window_Data.hide()
        gtk.main_quit()

class InviaDatabase() :

    def __init__(self):
        builder = gtk.Builder()
        builder.add_from_file("InviaDatabase-ui.xml") 
        builder.connect_signals(self)
        self.window_invia = builder.get_object("window_invia")
        self.link_entry = builder.get_object("link_entry")
        self.nome_entry = builder.get_object("nome_entry")
        self.annulla_button = builder.get_object("annulla_button")
        self.invia_button = builder.get_object("invia_button")
        self.combobox1 = builder.get_object("combobox1")

        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer'
        
        ####riempie combobox1
        self.liststore = gtk.ListStore(str)
        self.cell = gtk.CellRendererText()
        self.combobox1.pack_start(self.cell)
        self.combobox1.set_attributes(self.cell, text=0)
        
        self.liststore.append(["TV"])
        self.liststore.append(["RADIO"])
        self.combobox1.set_model(self.liststore)
        self.combobox1.set_active(0)
        ######
        
        self.window_invia.show()

    def invia(self,nome_entry):
        nome = self.nome_entry.get_text()
        link = self.link_entry.get_text()
        if self.combobox1.get_active()==0:
            type = "tv"
        else:
            type = "radio"
        if link=="" or nome=="" :
            print "Inserisci il nome ed il link"
        else :
            print nome
            print link
            print type
            phpdata = urllib.urlopen("http://tvplayersite.altervista.org/online/add.php?name="+nome+"&url="+link+"&type="+type)
            phpdata.close()
            self.window_invia.hide()
            gtk.main_quit()

    def annulla(self,window_add):
        self.window_invia.hide()
        gtk.main_quit()
 
    def main(self):
        gtk.main()

