#!/usr/bin/python
# -*- coding: utf-8 -*-

import gtk
import pygtk
import sys
import os

import urllib
import string

from libradiotv.webfetch import ListGenerator
from libradiotv.player import Player
from libradiotv.add import Add
from libradiotv.add import AddDatabase
from libradiotv.add import InviaDatabase
from libradiotv.threadXML import ThreadXML
from libradiotv.threadXML import ThreadXML_la7
from libradiotv.threadXML import ThreadXML_la7Cult
from libradiotv.tele import televideo
from libradiotv.dialog import Dialog_aggiornamenti

class Tele:
    def __init__(self):
		
        self.versione="0.8"

        self.listgen = ListGenerator()
        
        if not self.listgen.is_updated() :
            print "Lista Canali Non Presente!", "Verrà scaricata una lista aggiornata dal server."
            self.listgen.download()

        self.PLAYER=self.listgen.default_player()
        print "Player:"+self.PLAYER[0]


        builder = gtk.Builder()
        builder.add_from_file("ui.xml") 
        builder.connect_signals(self)
        self.window1 = builder.get_object("window1")
        self.window2 = builder.get_object("window2")
        self.dialog1 = builder.get_object("dialog1")
        self.notebook1 = builder.get_object("notebook1")
        self.treeview1 = builder.get_object("treeview1")
        self.treeview5 = builder.get_object("treeview5")
        self.treeview6 = builder.get_object("treeview6") 
        
        self.scrolledwindow5 = builder.get_object("scrolledwindow5") 
        self.scrolledwindow7 = builder.get_object("scrolledwindow7")
        self.vlc_item = builder.get_object("vlc_item")
        self.totem_item = builder.get_object("totem_item")
        self.mplayer_item = builder.get_object("mplayer_item")
        self.mplayerRAI_item = builder.get_object("mplayerRAI_item")
        self.personal_item = builder.get_object("personal_item")
        self.combobox1 = builder.get_object("combobox1")
        self.combobox2 = builder.get_object("combobox2")
        ##player
        self.entry_player = builder.get_object("entry_player")
        self.buttonOK_player = builder.get_object("buttonOK_player")
        self.buttonANN_player = builder.get_object("buttonANN_player")

        self.menu_popup = builder.get_object("menu_popup")
        self.statusbar = builder.get_object("statusbar")

        self.statusbar.push(1,"Benvenuto in Tv-Player")
        self.entry_player.set_text(self.PLAYER[1])


        if (self.PLAYER[0]=="vlc"):
            self.vlc_item.set_active(True)
            self.player = Player()
        elif (self.PLAYER[0]=="totem"):
            self.totem_item.set_active(True)
            self.player = Player("totem")
        elif (self.PLAYER[0]=="mplayer"):
            self.mplayer_item.set_active(True)
            self.player = Player("mplayer")
        elif (self.PLAYER[0]=="mplayerRAI"):
            self.mplayerRAI_item.set_active(True)
            self.player = Player("mplayerRAI")
        else:
            self.personal_item.set_active(True)
            self.player = Player(self.PLAYER[0])


		###treeview Personal
        self.model1 = gtk.ListStore(str,str) 
        self.treeview1.set_model(self.model1)

        self.treecol1 = gtk.TreeViewColumn("Lista")
        self.cellrenderer1 = gtk.CellRendererText()
        self.treecol1.pack_start(self.cellrenderer1, False)
        self.treecol1.set_attributes(self.cellrenderer1, text = 0)
        self.treeview1.append_column(self.treecol1)
		###
		
		###treeview La7 XML

        self.model5 = gtk.ListStore(gtk.gdk.Pixbuf,str,str) 
        self.treeview5.set_model(self.model5)
                
        self.treecol5 = gtk.TreeViewColumn("Programma")
        self.cellrenderer5 = gtk.CellRendererPixbuf()
        self.treecol5.pack_start(self.cellrenderer5, False)
        self.treecol5.set_attributes(self.cellrenderer5, pixbuf=0)
        self.treeview5.append_column(self.treecol5)

        self.treecol6 = gtk.TreeViewColumn("Lista")
        self.cellrenderer6 = gtk.CellRendererText()
        self.treecol6.pack_start(self.cellrenderer6, False)
        self.treecol6.set_attributes(self.cellrenderer6, markup=1)
        self.treeview5.append_column(self.treecol6)
		###
		
		###treeview TG REGIONALI
        self.model6 = gtk.ListStore(str,str) 
        self.treeview6.set_model(self.model6)

        self.treecol7 = gtk.TreeViewColumn("Lista")
        self.cellrenderer7 = gtk.CellRendererText()
        self.treecol7.pack_start(self.cellrenderer7, False)
        self.treecol7.set_attributes(self.cellrenderer7, markup = 0)
        self.treeview6.append_column(self.treecol7)
		###
		
		
		###liststore combobox1 REGISTRAZIONI
        self.liststore = gtk.ListStore(str)
        self.cell = gtk.CellRendererText()
        self.combobox1.pack_start(self.cell)
        self.combobox1.set_attributes(self.cell, text=0)
        
        self.liststore.append(["Registrazioni Rai"])
        self.liststore.append(["La7: La Settimana"])
        self.liststore.append(["La7: Archivio Cult"])
        self.liststore.append(["Tg Regionali"])
        self.combobox1.set_model(self.liststore)
        self.combobox1.set_active(0)
		###
		
		###liststore combobox2 TV/RADIO
        self.liststore2 = gtk.ListStore(str)
        self.cell2 = gtk.CellRendererText()
        self.combobox2.pack_start(self.cell2)
        self.combobox2.set_attributes(self.cell2, text=0)
        
        self.liststore2.append(["TV"])
        self.liststore2.append(["RADIO"])
        self.combobox2.set_model(self.liststore2)
        self.combobox2.set_active(0)
		###
        
        gtk.gdk.threads_init()
        self.window1.show()

    def comboTV_RADIO_change(self,data=None):
		###riempie lista TV/RADIO
        self.model1.clear()

        if self.combobox2.get_active()==0:
            self.type = "tv"
        else:
            self.type = "radio"
        self.WEB_PERSONAL = self.listgen.generatePersonalList(self.type)
        self.sort_PERSONAL = self.WEB_PERSONAL.keys()
        self.sort_PERSONAL.sort()
        for i in self.sort_PERSONAL :
            self.model1.append ([i,self.WEB_PERSONAL[i]])
		###

    def comboREGISTRAZIONI_change(self,data=None):
	     	
        if (self.combobox1.get_active()==0):
            print "Registrazioni Rai"   
            self.treeview5.hide()
            self.treeview6.show()
            self.scrolledwindow5.hide()
            self.scrolledwindow7.show()
	    	###scarica e riempie lista RAIXML
            self.model6.clear()
            self.model6.append(["Sto scaricando la lista...",""])

            th = ThreadXML(self.model6,self.statusbar,self.combobox1)
            th.start()
		    ###
	     	
        if (self.combobox1.get_active()==1):
            print "La7: La settimana"
            self.scrolledwindow7.hide()
            self.scrolledwindow5.show()
            self.treeview5.show()
            self.treeview6.hide()
	        ###scarica e riempie lista LA7 La settimana
            self.model5.clear()
         #   gtk.gdk.threads_init()

            th = ThreadXML_la7(self.model5,self.statusbar,self.combobox1)
            th.start()
		    ###
		    
        if (self.combobox1.get_active()==2):
            print "La7: Archivio Cult"
            self.scrolledwindow7.hide()
            self.scrolledwindow5.show()
            self.treeview5.show()
            self.treeview6.hide()
	        ###scarica e riempie lista LA7 Archivio cult
            self.model5.clear()
         #   gtk.gdk.threads_init()

            th = ThreadXML_la7Cult(self.model5,self.statusbar,self.combobox1)
            th.start()
		    ###
   
        if (self.combobox1.get_active()==3):
            print "Tg Regionali"   
		    ###riempie lista TG REGIONALI
            self.treeview5.hide()
            self.treeview6.show()
            self.scrolledwindow5.hide()
            self.scrolledwindow7.show()
            self.model6.clear()

            self.TGR = self.listgen.generateTGRList()
            self.sort_TGR = self.TGR.keys()
            self.sort_TGR.sort()
            for i in self.sort_TGR :
               self.model6.append ([i,self.TGR[i]])
	     	###


    def play(self,treeview1,data=None,data1=None):
		###play canale
        if self.notebook1.get_current_page() == 0:
			self.treeselection = self.treeview1.get_selection()
			(model,iter) = self.treeselection.get_selected()
			url = self.model1.get_value(iter, 1)
			print url
			self.statusbar.push(1,"Canale: "+self.model1.get_value(iter, 0))
			self.player.play(url)

        if self.notebook1.get_current_page() == 1 and self.combobox1.get_active()==0:
			self.treeselection = self.treeview6.get_selection()
			(model,iter) = self.treeselection.get_selected()
			url = self.model6.get_value(iter, 1)
			print url
			self.statusbar.push(1,"Registrazione Rai")
			self.player.play(url)
			
        if self.notebook1.get_current_page() == 1 and (self.combobox1.get_active()==1 or self.combobox1.get_active()==2):
			self.treeselection = self.treeview5.get_selection()
			(model,iter) = self.treeselection.get_selected()
			url = self.model5.get_value(iter, 2)
			print url
			self.statusbar.push(1,"Registrazione La7")
			#self.player.play(url)
			os.system("./la7.sh "+self.PLAYER[0]+" "+url+" &")
			
        if self.notebook1.get_current_page() == 1 and self.combobox1.get_active()==3:
			self.treeselection = self.treeview6.get_selection()
			(model,iter) = self.treeselection.get_selected()
			regione = self.model6.get_value(iter, 1)
			webfile = urllib.urlopen("http://www.tgr.rai.it/SITOTG/TGR_popupvideo/1,8506,tgr^puglia,00.html")
			web=webfile.read()
			webfile.close()
			media=web[string.find(web, regione+"tgr"):-1].split("'")
			url="http://www.inforegioni.rai.it/ram/regioni/"+regione+"/tgr/"+media[1]
			print url
			self.statusbar.push(1,"TG Regionale: "+self.model6.get_value(iter, 0))
			self.player.play(url)

    def exit(self,window1):
        sys.exit()

    def select_player(self, widget, data):
		###seleziona player predefinito
        if (widget.get_active()):
			if data=="personalizzato":
				data=self.PLAYER[1]
			self.PLAYER[0]=data
			print "Player:"+self.PLAYER[0]
			self.statusbar.push(1,"Player selezionato: "+self.PLAYER[0])
			self.listgen.write_player_config(self.PLAYER[0],self.PLAYER[1])
			self.player = Player(data)

    def show_select_player(self,window2):
        ###Mostra la finestra "Seleziona player"
        self.window2.show()
        
    def applica_player(self,data=None):
        self.PLAYER[0]=self.entry_player.get_text()
        self.PLAYER[1]=self.entry_player.get_text()
        self.statusbar.push(1,"Player selezionato: "+self.PLAYER[0])
        self.listgen.write_player_config(self.PLAYER[0],self.PLAYER[0])
        self.player = Player(self.PLAYER[0])
        self.personal_item.set_active(True)
        self.hide_select_player(self.window2)

    def hide_select_player(self,window2):
        ###Chiude la finestra "Seleziona player"
        self.window2.hide()

    def show_about(self,dialog1) :
        ###Mostra la finestra "InformazioniSu..."
        self.dialog1.show()

    def hide_about(self,dialog1) :
        ###Chiude la finestra "InformazioniSu..."
        self.dialog1.hide()
        
    def controlla_versione(self,data=None):
        self.controlla_aggiornamenti=Dialog_aggiornamenti(self.versione)
        self.controlla_aggiornamenti.main()
			
        
    def aggiungi(self,window1) :
        add = Add()
        add.main()
        self.comboTV_RADIO_change()

    def cancella_buttclick(self,model1) :
		if self.combobox2.get_active()==0:
			self.type = "tv"
		else:
			self.type = "radio"
		self.treeselection = self.treeview1.get_selection()
		(model,iter) = self.treeselection.get_selected()
		if iter:
			link_canale = self.model1.get_value(iter, 1)
			print "Elimino:"+link_canale
			self.statusbar.push(1, "Eliminato canale: "+self.model1.get_value(iter, 0))
			self.listgen.removeitemPersonalList(link_canale,self.type)
			self.comboTV_RADIO_change()
		else:
			print "Devi selezionare un canale"
			self.statusbar.push(1, "Devi selezionare un canale")

    def add_datatab(self,window1) :
        self.listgen.download_DATABASE()
        lista = self.listgen.generateDatabaseList()
        add = AddDatabase(lista)
        add.main()
        self.comboTV_RADIO_change()

    def invia_linkData(self,window1) :
        invia = InviaDatabase()
        invia.main()

    def menu_popup_show(self,menu_popup,event):
		if event.type == gtk.gdk.BUTTON_PRESS and event.button == 3:
			self.menu_popup.popup(None, None, None, event.button, event.time)
		if event.type == gtk.gdk.KEY_PRESS and event.keyval == 65535:
			self.cancella_buttclick(None)
			
    def televideo(self,data=None) :
        tele = televideo()
        tele.main()


    def main(self):
        self.vlc_item.connect("toggled", self.select_player, "vlc")
        self.totem_item.connect("toggled", self.select_player, "totem")
        self.mplayer_item.connect("toggled", self.select_player, "mplayer")
        self.mplayerRAI_item.connect("toggled", self.select_player, "mplayerRAI")
        self.personal_item.connect("toggled", self.select_player, "personalizzato")
        
        gtk.main()


if __name__ == "__main__":
    tele = Tele()
    tele.main()
